
#ifndef _CAMERA_DEPTH_RW_H_
#define _CAMERA_DEPTH_RW_H_

#include <fstream>
//#include <vector>
//#include <stdio.h>

#include "liblinjpeg.h"

using namespace std;

//#define USE_INFO_FILE

int __GetIntFromString(char *string);
void __GetStringFromInt(char *dest, int nbdigits, int source);
int __Modulo(int Mode, int source);
int __Modulo(int Mode, int source, int &quotient);
void __Modulo(int Mode, int source, int &out_quotient, int &out_remainder);

class depth_io_ClassBufferUC
{
public:
	int N;
	unsigned char *buffer;
	depth_io_ClassBufferUC();
	~depth_io_ClassBufferUC();
	void Kill();
	void Create(int _N);
	void Init(unsigned char val);
	int CopyFromUC(depth_io_ClassBufferUC &src);
	int CopyFromUC(unsigned char *src);
};
class depth_io_ClassBufferUC1D
{
public:
	int N1D;
	depth_io_ClassBufferUC *arr1D;
	void Kill();
	depth_io_ClassBufferUC1D();
	~depth_io_ClassBufferUC1D();
	void Create(int _N1D, int _N);
	void Init(unsigned char val);
	int CopyFromUC(depth_io_ClassBufferUC1D &src);
};
class depth_io_ClassBufferUS
{
public:
	int N;
	unsigned short *buffer;
	depth_io_ClassBufferUS();
	~depth_io_ClassBufferUS();
	void Kill();
	void Create(int _N);
	void Init(unsigned short val);
};
class depth_io_ClassBufferBOOL
{
public:
	int N;
	bool *buffer;
	depth_io_ClassBufferBOOL();
	~depth_io_ClassBufferBOOL();
	void Kill();
	void Create(int _N);
	void Init(bool val);
	bool CopyFrom(depth_io_ClassBufferBOOL &src);
};
class depth_io_ClassBuffer
{
public:
	int N;
	float *buffer;
	depth_io_ClassBuffer();
	~depth_io_ClassBuffer();
	void Create(int _N);
	void Kill();
	void Init(float val);
	int CopyFrom(depth_io_ClassBuffer &src);
	int CopyFrom(float *src);
};
class depth_io_ClassBufferDOUBLE
{
public:
	int N;
	double *buffer;
	depth_io_ClassBufferDOUBLE();
	~depth_io_ClassBufferDOUBLE();
	void Create(int _N);
	void Kill();
	void Init(double val);
	int CopyFrom(depth_io_ClassBufferDOUBLE &src);
	int CopyFrom(double *src);
};
class depth_io_ClassBuffer1D
{
public:
	int N1D;
	depth_io_ClassBuffer *arr1D;
	int GetN1D();
	depth_io_ClassBuffer1D();
	depth_io_ClassBuffer1D(int _N1D, int _N);
	~depth_io_ClassBuffer1D();
	void CreatePartially(int _N1D);
	bool Create(int _N1D, int _N);
	void Init(float val);
	void Kill();
};
class depth_io_ClassBufferChar
{
public:
	int N;
	char *buffer;
	void Kill();
	depth_io_ClassBufferChar();
	depth_io_ClassBufferChar(int _N);
	~depth_io_ClassBufferChar();
	void Create(int _N);
	int CopyFrom(depth_io_ClassBufferChar &src);
	//int CopyFrom(char *src);
};

class depth_io_ClassBufferChar1D
{
public:
	int N1D;
	depth_io_ClassBufferChar *arr1D;
	void Kill();
	depth_io_ClassBufferChar1D();
	~depth_io_ClassBufferChar1D();
	void Create(int _N1D, int _N);
	int Insert(char *src);
	int GetCounter();
	void ResetCounter();
private:
	int Counter;
};
class depth_io_ClassBufferINT
{
public:
	int N;
	int *buffer;
	void Kill();
	depth_io_ClassBufferINT();
	depth_io_ClassBufferINT(int _N);
	~depth_io_ClassBufferINT();
	void Create(int _N);
	void Init(int val);
};
/*class depth_io_ClassBufferDOUBLE
{
public:
	int N;
	double *buffer;
	void Kill();
	depth_io_ClassBufferDOUBLE();
	depth_io_ClassBufferDOUBLE(int _N);
	~depth_io_ClassBufferDOUBLE();
	void Create(int _N);
	void Init(double val);
};*/

/*class depth_io_ClassBuffer1DINT
{
public:
	int N1D;
	depth_io_ClassBufferINT *arr1D;
	void Kill();
	depth_io_ClassBuffer1DINT();
	depth_io_ClassBuffer1DINT(int _N1D, int _N);
	~depth_io_ClassBuffer1DINT();
	void Create(int _N1D, int _N);
	void Init(int val);
};*/

struct struct_read_write_depth
{
	JpegFile jpgfile;
	char temp_filename[512];
  
	int width, height;
	int *Label;
	float *LabelRefZ;
	int *Encode;
	unsigned char *EncodeUC;
	unsigned char *EncodeUC2;
	bool *ErrorMap;
	int *ErrorCorrect;
	int *RLE_Nb;
	int *RLE_Val;
	int RLE_NbNb;

	float loaded_a11, loaded_a22, loaded_cx, loaded_cy;
	float *LoadedDepth, *LoadedMapX, *LoadedMapY;
	unsigned char *LoadedColourImage;

	int *write_MapObject; // for writing
};
void InitStruct(struct_read_write_depth &src);
bool Allocate(struct_read_write_depth &src, int _width, int _height);
void DeAllocate(struct_read_write_depth &src);

class EC_RGBD_CameraCompression
{
public:
	EC_RGBD_CameraCompression();
	EC_RGBD_CameraCompression(int SizeBuffer);
	
	bool REVERSE_NAME;
	
	bool Record;
	char Record_directory[512];
	char Record_stem_depth[128];
	char Record_stem_bgr[128];
	int Record_number_digits;
	
	int SizeHistory, HistoryModCounter;
	int GetHistoryCorrespondingIndex(int frame_index);
	int GetHistoryCorrespondingTimeStamp(char *timestamp, int frame_index);
	depth_io_ClassBuffer1D HistoryDepth; // [0:65,535] for unsigned short int
	depth_io_ClassBufferUC1D HistoryBGR;
	depth_io_ClassBufferChar1D HistoryTimeStamp;
	depth_io_ClassBufferINT HistoryYear, HistoryMonth, HistoryDay, HistoryHour, HistoryMinute, HistorySecond, HistoryMillisecond;
	
	bool USE_FRAME_DIFF;
	float pct_moving;
	depth_io_ClassBuffer DisplayMovingFrame;
	float threshold_motion_contrast, threshold_pct_motion;
	
	bool Record_period;
	int Record_period_gap;
	int last_time_recorded_at;

	// DOES NOT WORK !!!!!!!!!!! float last_unix_time_recorded;
	int last_time_recorded_year, last_time_recorded_month, last_time_recorded_day, last_time_recorded_hour, last_time_recorded_minute, last_time_recorded_second, last_time_recorded_millisecond;

	bool RECORDED, INITIALISED;
	
	void start_recording(
		char *directory, // where the 4 files will be saved
		char *stem,//_rle, char *stem_ref, char *stem_jpg, char *stem_err,
		int number_digits);
	
	void start_recording(
		char *directory, // where the 4 files will be saved
		char *stem_depth,//_rle, char *stem_ref, char *stem_jpg, char *stem_err,
		char *stem_bgr,
		int number_digits);
	
	void stop_recording();
	
	bool apply(int current_frame, int debug);
	/// int current_frame IMPORTNAT for  hostoy index to save in buffer
	bool apply_with_timestamp(int current_frame, int year, int month, int day, int hour, int minute, int second, int millisecond, float THRESHOLD_INTERVAL_FPS, int debug);
	bool _apply(
		bool SAVE_WITH_TIMESTAMP, 
		int current_frame, 
		int year, int month, int day, int hour, int minute, int second, int millisecond, float THRESHOLD_INTERVAL_FPS, int debug);

	/*bool recording(int start_frame_index, int stop_frame_index,
		int current_frame,
		char *directory, // where the 4 files will be saved
		char *stem,//_rle, char *stem_ref, char *stem_jpg, char *stem_err,
		int number_digits);
	bool recording(int start_frame_index, int stop_frame_index,
		int current_frame,
		char *directory, // where the 4 files will be saved
		char *stem_depth,//_rle, char *stem_ref, char *stem_jpg, char *stem_err,
		bool COLOUR_IMAGE_ON, char *stem_bgr,
		int number_digits);*/
	
	
	bool recording(int start_frame_index, int stop_frame_index,
		int current_frame,
		char *directory, // where the 4 files will be saved
		char *stem_depth,//_rle, char *stem_ref, char *stem_jpg, char *stem_err,
		int number_digits, int debug);

	bool recording(
		int start_year, int start_month, int start_day, int start_hour, int start_minute, int start_second, int start_millisecond,
		int stop_year, int stop_month, int stop_day, int stop_hour, int stop_minute, int stop_second, int stop_millisecond,
		char *directory, // where the 4 files will be saved
		char *stem_depth, int debug);//_rle, char *stem_ref, char *stem_jpg, char *stem_err,
		//int number_digits);

	bool recording(int start_frame_index, int stop_frame_index, 
		int current_frame,
		char *directory, // where the 4 files will be saved
		char *stem_depth,//_rle, char *stem_ref, char *stem_jpg, char *stem_err,
		/*bool COLOUR_IMAGE_ON, */char *stem_bgr,
		int number_digits, int debug);

	bool recording(
		int start_year, int start_month, int start_day, int start_hour, int start_minute, int start_second, int start_millisecond,
		int stop_year, int stop_month, int stop_day, int stop_hour, int stop_minute, int stop_second, int stop_millisecond,
		char *directory, // where the 4 files will be saved
		char *stem_depth,//_rle, char *stem_ref, char *stem_jpg, char *stem_err,
		/*bool COLOUR_IMAGE_ON, */char *stem_bgr, int debug);//int number_digits);

	bool _recording(
		bool SAVE_WITH_TIMESTAMP,
		int start_year, int start_month, int start_day, int start_hour, int start_minute, int start_second, int start_millisecond,
		int stop_year, int stop_month, int stop_day, int stop_hour, int stop_minute, int stop_second, int stop_millisecond,
		int start_frame_index, int stop_frame_index, int current_frame,
		char *directory, // where the 4 files will be saved
		char *stem_depth,//_rle, char *stem_ref, char *stem_jpg, char *stem_err,
		bool COLOUR_IMAGE_ON, char *stem_bgr,
		int number_digits, int debug);

	void Construct(int SizeBuffer);
	void release();
	
	bool read(float *depthMap, //unsigned short *depthMap,
		char *dir_in, char *stem_filename, int number_digits, int current_frame);


	bool read(float *depthMap, //unsigned short *depthMap,
		char *dir_in, char *stem_filename, int year, int month, int day, int hour, int minute, int second, int millisecond);


	bool _read(float *depthMap, //unsigned short *depthMap,
		char *dir_in, char *stem_filename, 
		bool SAVED_WITH_TIMESTAMP, int number_digits, int current_frame, int year, int month, int day, int hour, int minute, int second, int millisecond);
	
	
	
	
	bool read(float *depthMap, //unsigned short *depthMap, 
			  unsigned char *bgrImage,
		char *dir_in, char *stem_filename, char *stem_rgbimage, int number_digits, int current_frame);

	bool read(float *depthMap, //unsigned short *depthMap, 
			  unsigned char *bgrImage,
		char *dir_in, char *stem_filename, char *stem_rgbimage, int year, int month, int day, int hour, int minute, int second, int millisecond);
	
	/// NEW
	bool read(float *depthMap, //unsigned short *depthMap, 
		char *dir_in, char *stem_filename, char *stem_stamp);
	
	bool read(float *depthMap, //unsigned short *depthMap, 
			  unsigned char *bgrImage,
		char *dir_in, char *stem_filename, char *stem_rgbimage, char *stem_stamp);

	bool _read(float *depthMap, //unsigned short *depthMap, 
			   unsigned char *bgrImage,
		char *dir_in, char *stem_filename, char *stem_rgbimage, 
		bool SAVED_WITH_TIMESTAMP, int number_digits, int current_frame, int year, int month, int day, int hour, int minute, int second, int millisecond);

	bool read_for_calib_tool(float *depthMap, //unsigned short *depthMap, 
					   unsigned char *bgrImage, char *depth_filename, char *bgr_filename);
	bool read_for_calib_tool(float *depthMap, char *depth_filename);
	
	int VERIFICATION;
	/*bool write(float *depthMap, // unsigned short *depthMap,
		char *directory, // where the 4 files will be saved
		char *stem,//_rle, char *stem_ref, char *stem_jpg, char *stem_err,
		int number_digits, int current_frame);
	*/
	
	#ifdef USE_OPENCV_DISPLAY
	bool display_depth(char *window);
	bool display_bgrImage(char *window);
	bool display(char *window1, char *window2);
	bool display_motion(char *window);
	#endif
	~EC_RGBD_CameraCompression();
	
	
	void output_to_cvMat_depth(float *depthMap);//unsigned short *depthMap);
	void output_to_cvMat_bgrImage(unsigned char *bgrImage);
	void input(float *depthMap);//unsigned short *depthMap);
	void input(float *depthMap, //unsigned short *depthMap, 
			   unsigned char *bgrImage);
	//#endif
	float GetDepthAt(int pixel_index);
	void SetDepthAt(int pixel_index, float val);
	unsigned char GetBgrImageAt(int pixel_index);
	void SetBgrImageAt(int pixel_index, unsigned char val);

	
	float GetIntrinsic_a11();
	float GetIntrinsic_a22();
	float GetIntrinsic_cx();
	float GetIntrinsic_cy();
	
	int Current_Frame_Index;
	
	JpegFile jpgfile; 
	//JpegFile linjpg;
	depth_io_ClassBuffer tempF;
	depth_io_ClassBufferUS tempUS;
	
	int Debug, printout;
	char temp_string[512], temp_strdest[10];

private:
	int WW, HH;
	depth_io_ClassBufferUC colour_image; bool COLOUR_IMAGE_ON;
	depth_io_ClassBuffer MapXd, MapYd, MapZd;
	depth_io_ClassBufferBOOL MapHasDepth, prev_MapHasDepth;
	float a11, a22, cx, cy;

	/// streaming from camera live
	/*std::shared_ptr< ntk::OpenniDriver > m_spOpenNIDriver;
	std::shared_ptr< ntk::RGBDGrabber > m_spGrabber;
	std::shared_ptr< ntk::RGBDImage > m_spRGBDImage;
	std::shared_ptr< ntk::RGBDProcessor > m_spPostProcessor;
	std::shared_ptr<ntk::RGBDCalibration> m_spCalibration;*/
	
	/// no more for SUP
	/*/// reading recored uncompressed data, file to file (per view)
	KinectReader_file_to_file ReaderUncompressed_ftf;
	char ReaderUncompressed_ftf_calib_filename[256];
	char ReaderUncompressed_ftf_colour_filename[256]; bool LOAD_RGB; // false
	char ReaderUncompressed_ftf_depth_raw_filename[512];*/
		
	/// reading/writing recored compressed data (file to file)
	struct_read_write_depth RW;
	depth_io_ClassBufferChar timestamp;//[27];
	int HistoryCounter;
	//cv::Mat I_cv_mat, O_cv_mat_uc1, O_cv_mat_uc3;
};

bool write_compressed_data(bool REVERSE_NAME,//JpegFile &jpgfile,
	int VERIFICATION, struct_read_write_depth &src,
	char *directory, // where the 4 files will be saved
	char *stem_depth,//_rle, char *stem_ref, char *stem_jpg, char *stem_err,
	bool COLOUR_IMAGE_ON, char *stem_bgr, unsigned char *colour_image,
	bool SAVE_WITH_TIMESTAMP, int number_digits, int m_frameNb, char *timestamp,
	float *MapZ, //char *dir_out, int m_frameNb,
	float a11, float a22, float cx, float cy, int debug);

bool load_compressed_data(struct_read_write_depth &src, char *FILENAME, int debug);
//bool load_compressed_data(bool REVERSE_NAME,//JpegFile &jpgfile,
//	struct_read_write_depth &src, char *dir_in, char *stem, 
//	bool SAVED_WITH_TIMESTAMP, int number_digits, int m_frameNb, char *timestamp, int debug);

bool load_compressed_data_baptiste(struct_read_write_depth &src, char *depth_filename);

//#ifdef USE_OPENCV_JPEG
//void _display_opencv_mat_depth(cv::Mat &depthMap, char *window);
//void _display_opencv_mat_bgrImage(cv::Mat &depthMap, char *window);
//#endif

/// timestamp of 27 chars (3 remaining chars as extra time precision)
/// 2008-06-12T08:12:12.840800
/// 01234567890123456789012345 [26]='\0'
void GetTimeStampString(char *timestamp, int year, int month, int day, int hour, int minute, int second, int millisecond, int debug);
bool GetTimeStampFromString(char *stamp_string, int &year, int &month, int &day, int &hour, int &minute, int &second, int &millisecond, int debug);
int ConvertTimeStampToUnixTime(double &unixtime, int year, int month, int day, int hour, int minute, int second, int millisecond, int PRINT);
void IncrementTimeStampMilliSecond(int INTERVAL, int &year, int &month, int &day, int &hour, int &minute, int &second, int &millisecond);

bool _get_timestamp_from_stamp_stem(char *dir_in, char *stem_filename, char *stem_stamp, 
	int &year, int &month, int &day, int &hour, int &minute, int &second, int &millisecond);

/*
class CalendarInstance
{
public:
	CalendarInstance();
	~CalendarInstance();
	CalendarInstance& operator= (CalendarInstance& source);
	int year, month, total_nb_days;//, day;
};

class ECArrayData_CalendarInstance
{
public:
	int NbMax, Nb;
	CalendarInstance *buf;

	ECArrayData_CalendarInstance();
	~ECArrayData_CalendarInstance();
	ECArrayData_CalendarInstance(int tempN);
//	int Create(int tempN, int tempid);
	int InsertCalend(CalendarInstance &V);// returns index
	int Kill();
	int Create(int tempN);
	int CopyFrom(ECArrayData_CalendarInstance &source);
};
int LookUpCalendar(int max_year, ECArrayData_CalendarInstance &Calend);

int ConvertUnixTimeToTimeStamp(int &year, int &month, int &day, int &hour, int &minute, int &second, int &millisecond, double unixtime, ECArrayData_CalendarInstance &Calend);
*/
//void calibration_save_uncomressed(cv::Mat &depthMap, cv::Mat &bgrImage, char *bgr_raw_filename, char *depth_raw_filename);

#ifdef SAVE_PNG_CALIB
void calibration_save_uncompressed(int WW, int HH, 
	float *depthMap, char *depth_raw_filename,
	unsigned char *bgrImage, char *bgr_raw_filename);
	//char *calib_filename);
#endif // SAVE_PNG_CALIB

void calibration_save_uncompressed(int WW, int HH, 
	float *depthMap, char *depth_raw_filename);
	//char *calib_filename);

/// input: 0/44.0f, 1/256.0f, 2/78.0f,   3/2.0f,    4/1.0
/// output: 4/1.0,   3/2.0f,   0/44.0f,   2/78.0f,   1/256.0f
int BubbleSort(int Length, double *pt, int *index, int n);	// indexes are swaped according to the sort of pt
int BubbleSort(int Length, double *pt, int *index, int n, bool INCREASE);	// indexes are swaped according to the sort of pt

/// 10,000 frames per folder (50,000 files) with 8fps => 500 folders for one week
/// 5,000 frames / folder (25,000 files) for 8fps => 1000 folders for one week
/*
8 f - 1 s
480 f - 1 mn
500 f - 1 mn
5000 f = 10 mn - 1 folder
1 hr - 6 folders
24 hr - 144 folder
7 j - 1008 folders */

void CreateSubDirBatch(char *directory, int MaxNbSubDirectories);

/// OLD
void ReadSubDirBatch_part1(char *directory, int MaxNbSubDirectories);
void ReadSubDirBatch_part2(char *directory, int MaxNbSubDirectories);
int ReadNbSubDir(char *directory, int MaxNbSubDirectories);

/// NEW
int ListEntriesInDir(const char* dirname);
int ListEntriesInSubDir(const char* dirname, depth_io_ClassBufferChar1D &SortedStamps, 
	depth_io_ClassBufferChar1D &TimeStamps, depth_io_ClassBufferDOUBLE &UnixTimes, depth_io_ClassBufferINT &SortedIndex
); // only used by rw3 version
int ReadInfoNbSubDir(char *dirname);
int countEntriesInDir_main(int argc, char* argv[]);

#endif
