
#ifndef _CAMERA_DEPTH_RW2_H_
#define _CAMERA_DEPTH_RW2_H_

#include "camera_depth_rw.h"

class EC_RGBD_CameraCompression2_parameters
{
public:
	EC_RGBD_CameraCompression2_parameters();
	~EC_RGBD_CameraCompression2_parameters();
	void CopyFrom(EC_RGBD_CameraCompression2_parameters &src);
	
	bool SetCameraType(int val);
	bool SetWriteOrRead(char src);
	void SetSizeBuffer(int _size);
	void SetDirectory(char *_dir);
	#ifdef OLD_MANAGER_SUB_FOLDERS // where we add to first create sub folders before launching writer
	bool ActivateSubDirectory(int _nbsub, int _nbframes);
#else
	bool ActivateSubDirectory(int _nbframes);
#endif
	bool ActivateSubDirectory();
	void SetDepthStem(char *_stem);
	void SetBGRStem(char *_stem);
	//void SetNbDigits(int _nb);
	void SetMaxFPS(float _fps);
	
	int CameraType; bool CameraType_active;
	char WriteOrRead; bool WriteOrRead_active;
	int SizeBuffer; bool SizeBuffer_active;
	char Directory[512]; bool Directory_active;
#ifdef OLD_MANAGER_SUB_FOLDERS // where we add to first create sub folders before launching writer
	int NbSubDirectories, NbFramesPerSubDirectory; bool SubDirectory_active;
#else
	int NbFramesPerSubDirectory; bool SubDirectory_active;
#endif
	char DepthStem[256]; bool DepthStem_active;
	char BGRStem[256]; bool BGRStem_active;
	//int NbDigits; bool NbDigits_active;
	float MaxFPS; bool MaxFPS_active;
};

class EC_RGBD_CameraCompression2
{
public:
	EC_RGBD_CameraCompression2();
	EC_RGBD_CameraCompression2(EC_RGBD_CameraCompression2_parameters &_param);
	~EC_RGBD_CameraCompression2();
	bool Construct(EC_RGBD_CameraCompression2_parameters &_param);
	void release();	

	EC_RGBD_CameraCompression2_parameters param;
	
//	bool Record;
//	char Record_directory[512];
//	char Record_stem_depth[128];
//	char Record_stem_bgr[128];
//	int Record_number_digits;
	
	/// FILE *fSubDir_w; not used anymore, we prefer to launch ''
	///  ListEntriesInDir once and for all after recording is done
	///  and ReadInfoNbSubDir for every time we read the recorded data

	FILE *fSubDir_r;
	bool REVERSE_NAME;
	
	bool USE_FRAME_DIFF;
	float pct_moving;
	depth_io_ClassBuffer DisplayMovingFrame;
	float threshold_motion_contrast, threshold_pct_motion;
	
	bool Record_period;
	int Record_period_gap;
	int delta_time_last_recorded;
	
	int last_time_recorded_year, last_time_recorded_month, last_time_recorded_day, last_time_recorded_hour, last_time_recorded_minute, last_time_recorded_second, last_time_recorded_millisecond;
	double last_time_recorded_unixtime;
	
	bool RECORDED, INITIALISED;
//	int Current_Frame_Index;
	JpegFile jpgfile; 
	//JpegFile linjpg;
	//depth_io_ClassBuffer tempF;
	//depth_io_ClassBufferUS tempUS;
	//int Debug, printout;
	int WW, HH;
	//depth_io_ClassBufferUC colour_image; //bool COLOUR_IMAGE_ON;
	//depth_io_ClassBuffer MapXd, MapYd, MapZd;
	depth_io_ClassBufferBOOL MapHasDepth;
	depth_io_ClassBufferBOOL prev_MapHasDepth;
	float a11, a22, cx, cy;
	struct_read_write_depth RW;
	depth_io_ClassBufferChar timestamp;//[27];
		
	float *DepthMap;
	unsigned char *ColourImage;

	
	/*void start_recording(
		char *directory, // where the 4 files will be saved
		char *stem,//_rle, char *stem_ref, char *stem_jpg, char *stem_err,
		int number_digits);
	
	void start_recording(
		char *directory, // where the 4 files will be saved
		char *stem_depth,//_rle, char *stem_ref, char *stem_jpg, char *stem_err,
		char *stem_bgr,
		int number_digits);
	
	void stop_recording();
	*/
	bool apply_with_index(bool RECORD_NOW, int current_frame, int debug);
	/// int current_frame IMPORTNAT for  hostoy index to save in buffer
	bool apply_with_timestamp(bool RECORD_NOW, int current_frame, int year, int month, int day, int hour, int minute, int second, int millisecond, int debug);
	
	bool _apply(bool RECORD_NOW, //float *DepthMap, unsigned char *ColourImage,
		bool SAVE_WITH_TIMESTAMP, 
		int current_frame, 
		int year, int month, int day, int hour, int minute, int second, int millisecond, int debug);

	/*bool recording_from_buffer(int start_frame_index, int stop_frame_index,
		int current_frame,
		char *directory, // where the 4 files will be saved
		char *stem_depth,//_rle, char *stem_ref, char *stem_jpg, char *stem_err,
		int number_digits, int debug);

	bool recording_from_buffer(
		int start_year, int start_month, int start_day, int start_hour, int start_minute, int start_second, int start_millisecond,
		int stop_year, int stop_month, int stop_day, int stop_hour, int stop_minute, int stop_second, int stop_millisecond,
		char *directory, // where the 4 files will be saved
		char *stem_depth, int debug);//_rle, char *stem_ref, char *stem_jpg, char *stem_err,
		//int number_digits);
*/
	bool recording_from_buffer(int start_frame_index, int stop_frame_index, 
		int current_frame,
	//	char *directory, // where the 4 files will be saved
	//	char *stem_depth,//_rle, char *stem_ref, char *stem_jpg, char *stem_err,
	//	char *stem_bgr,
	//	int number_digits, 
		int print, int debug);

	bool recording_from_buffer(
		int start_year, int start_month, int start_day, int start_hour, int start_minute, int start_second, int start_millisecond,
		int stop_year, int stop_month, int stop_day, int stop_hour, int stop_minute, int stop_second, int stop_millisecond,
	//	char *directory, // where the 4 files will be saved
	//	char *stem_depth,//_rle, char *stem_ref, char *stem_jpg, char *stem_err,
	//	char *stem_bgr, 
		int print, int debug);//int number_digits);

	bool _recording_from_buffer(
		bool SAVE_WITH_TIMESTAMP,
		int start_year, int start_month, int start_day, int start_hour, int start_minute, int start_second, int start_millisecond,
		int stop_year, int stop_month, int stop_day, int stop_hour, int stop_minute, int stop_second, int stop_millisecond,
		int start_frame_index, int stop_frame_index, int current_frame,
	//	char *directory, // where the 4 files will be saved
	//	char *stem_depth,//_rle, char *stem_ref, char *stem_jpg, char *stem_err,
	//	bool COLOUR_IMAGE_ON, char *stem_bgr,
	//	int number_digits, 
		int print, int debug);

	
	bool LoadColourImage(char *FILENAME);//char *dir_in, char *stem_rgbimage, 
	//	int current_frame, 
	//	//int year, int month, int day, int hour, int minute, int second, int millisecond,
	//	char *_timestamp,
	//	bool SAVED_WITH_TIMESTAMP, int printout);
	
	bool READ(int current_frame, int debug);
		
	/*bool read(int current_frame, int debug);
	bool read(int year, int month, int day, int hour, int minute, int second, int millisecond, int debug);
	bool read(char *stem_stamp, int debug);

	bool _read(bool SAVED_WITH_TIMESTAMP, 
		int current_frame, int year, int month, int day, int hour, int minute, int second, int millisecond, 
		int debug);
	
	bool read_sub_dir(int current_frame, int debug);
	*/
	
	/// read or write
	char depth_string[512], bgr_string[512];
	
	int _CurrentFrame; bool _CurrentFrame_active;
	bool SetCurrentFrame(int val);
	//FirstIndexSavedInSubDirectory
	int _CurrentYear, _CurrentMonth, _CurrentDay, _CurrentHour, _CurrentMinute, _CurrentSecond, _CurrentMillisecond;
	bool _CurrentTimeStamp_active;
	bool SetCurrentTimeStamp(int year, int month, int day, int hour, int minute, int second, int millisecond);
	
	bool SetCurrentTimeStamp(char *src);
	char _CurrentStampString[100]; bool _CurrentStampString_active;

	
	bool Read(int debug);
	

	bool read_for_calib_tool(char *depth_filename, char *bgr_filename);
	bool read_for_calib_tool(char *depth_filename);
	
	int VERIFICATION;

//	void output_to_cvMat_depth(float *depthMap);//unsigned short *depthMap);
//	void output_to_cvMat_bgrImage(unsigned char *bgrImage);
//	void input(float *depthMap);//unsigned short *depthMap);
//	void input(float *depthMap, //unsigned short *depthMap, 
//			   unsigned char *bgrImage);
	//#endif
//	float GetDepthAt(int pixel_index);
//	void SetDepthAt(int pixel_index, float val);
//	unsigned char GetBgrImageAt(int pixel_index);
//	void SetBgrImageAt(int pixel_index, unsigned char val);

	float GetIntrinsic_a11();
	float GetIntrinsic_a22();
	float GetIntrinsic_cx();
	float GetIntrinsic_cy();
	int CurrentNbFramesSavedInSubDirectory;
	int CurrentSubDirectoryIndex;
	char temp_string[512], temp_string2[512], temp_strdest[10], _temp_str[512];
	int FirstIndexSavedInSubDirectory;
	depth_io_ClassBufferChar FirstTimeStampSavedInSubDirectory;
	
	//int HistoryCounter;
	//int GetHistoryCorrespondingIndex(int frame_index);
	//int GetHistoryCorrespondingTimeStamp(char *timestamp, int frame_index);
	depth_io_ClassBuffer1D HistoryDepth; // [0:65,535] for unsigned short int
	depth_io_ClassBufferUC1D HistoryBGR;
	depth_io_ClassBufferChar1D HistoryTimeStamp;
	depth_io_ClassBufferINT HistoryYear, HistoryMonth, HistoryDay, HistoryHour, HistoryMinute, HistorySecond, HistoryMillisecond;
	depth_io_ClassBufferDOUBLE HistoryUnixTimes;
	
	int GetSizeHistory();
	int GetHistoryIndex();
	int GetHistoryOldest();
private:
	int SizeHistory;
	int HistoryModCounter, o_HistoryIndex; 
	/// o_HistoryIndex = HistoryModCounter, however, at the end of apply modcounter updated and for the main program we cannot use the correct one (non updated before the next framne)
	
	bool SubDirHandle(bool SAVE_WITH_TIMESTAMP, int current_frame);
	void SubDirUpdate();
};

/*
//#ifdef USE_OPENCV_JPEG
//void _display_opencv_mat_depth(cv::Mat &depthMap, char *window);
//void _display_opencv_mat_bgrImage(cv::Mat &depthMap, char *window);
//#endif

/// timestamp of 27 chars (3 remaining chars as extra time precision)
/// 2008-06-12T08:12:12.840800
/// 01234567890123456789012345 [26]='\0'
void GetTimeStampString(char *timestamp, int year, int month, int day, int hour, int minute, int second, int millisecond, int debug);
int ConvertTimeStampToUnixTime(double &unixtime, int year, int month, int day, int hour, int minute, int second, int millisecond, int PRINT);
void IncrementTimeStampMilliSecond(int INTERVAL, int &year, int &month, int &day, int &hour, int &minute, int &second, int &millisecond);

//void calibration_save_uncomressed(cv::Mat &depthMap, cv::Mat &bgrImage, char *bgr_raw_filename, char *depth_raw_filename);

#ifdef SAVE_PNG_CALIB
void calibration_save_uncompressed(int WW, int HH, 
	//float *depthMap, 
	char *depth_raw_filename,
	//unsigned char *bgrImage, 
	char *bgr_raw_filename);
	//char *calib_filename);
#endif // SAVE_PNG_CALIB

void calibration_save_uncompressed(int WW, int HH, 
	//float *depthMap, 
	char *depth_raw_filename);
	//char *calib_filename);

*/
/// 10,000 frames per folder (50,000 files) with 8fps => 500 folders for one week
/// 5,000 frames / folder (25,000 files) for 8fps => 1000 folders for one week
/*
8 f - 1 s
480 f - 1 mn
500 f - 1 mn
5000 f = 10 mn - 1 folder
1 hr - 6 folders
24 hr - 144 folder
7 j - 1008 folders */
/*
void CreateSubDirBatch(char *directory, int MaxNbSubDirectories);

/// OLD
void ReadSubDirBatch_part1(char *directory, int MaxNbSubDirectories);
void ReadSubDirBatch_part2(char *directory, int MaxNbSubDirectories);
int ReadNbSubDir(char *directory, int MaxNbSubDirectories);

/// NEW
int ListEntriesInDir(const char* dirname);
int ReadInfoNbSubDir(char *dirname);
int countEntriesInDir_main(int argc, char* argv[]);
*/
#endif


			