
#ifndef _CAMERA_DEPTH_RW3_H_
#define _CAMERA_DEPTH_RW3_H_

#include "camera_depth_rw.h"
#include <errno.h> // for mkdir return status

/*
 * t=0, 1st frame to be saved: check if day dir exist.
if yes ok make it the current day dir, 
else create it and make it the current day dir
  
check when we pass from one hour to another (if first frame previous one is <0 year)
create the current time folder

/home/inria/CAR/2013-06-26
T17-00-16*/

class EC_RGBD_CameraCompression3_parameters
{
public:
	EC_RGBD_CameraCompression3_parameters();
	~EC_RGBD_CameraCompression3_parameters();
	void CopyFrom(EC_RGBD_CameraCompression3_parameters &src);



	bool SetCameraType(int val);
	bool SetWriteMode();
	bool SetReadMode(
		int start_year, int start_month, int start_day, int start_hour, int start_minute, int start_second, int start_millisecond,
		int stop_year, int stop_month, int stop_day, int stop_hour, int stop_minute, int stop_second, int stop_millisecond);
	void SetSizeBuffer(int _size);
	void SetDirectory(char *_dir);
	//bool ActivateSubDirectory(int _nbframes); // for writer i think
	//bool ActivateSubDirectory(); // for reader i think
	void SetDepthStem(char *_stem);
	void SetBGRStem(char *_stem);
	//void SetNbDigits(int _nb);
	void SetMaxFPS(float _fps);
	
	int CameraType; bool CameraType_active;
	char WriteOrRead; bool WriteOrRead_active;
	int SizeBuffer; bool SizeBuffer_active;
	char Directory[512]; bool Directory_active;
	
	//int NbFramesPerSubDirectory; 
	//bool SubDirectory_active;
	
	char DepthStem[256]; bool DepthStem_active;
	char BGRStem[256]; bool BGRStem_active;
	//int NbDigits; bool NbDigits_active;
	float MaxFPS; bool MaxFPS_active;
	
	/// to manage sub folder which use only day and hour (not min, sec ..)
	//double ReadFolder_Current_Unixtime;
	double ReadFolder_Start_Unixtime;
	double ReadFolder_Stop_Unixtime;
	int ReadFolder_Start_Year, ReadFolder_Start_Month, ReadFolder_Start_Day, ReadFolder_Start_Hour;
	int ReadFolder_Stop_Year, ReadFolder_Stop_Month, ReadFolder_Stop_Day, ReadFolder_Stop_Hour;
	int ReadFolder_Current_Year, ReadFolder_Current_Month, ReadFolder_Current_Day, ReadFolder_Current_Hour;
	
	int ReadFolder_Start_Minute, ReadFolder_Start_Second, ReadFolder_Start_Millisecond;
	int ReadFolder_Stop_Minute, ReadFolder_Stop_Second, ReadFolder_Stop_Millisecond;
	int ReadFolder_Current_Minute;//, ReadFolder_Current_Second, ReadFolder_Current_Millisecond;
};

class EC_RGBD_CameraCompression3
{
public:
	EC_RGBD_CameraCompression3();
	EC_RGBD_CameraCompression3(EC_RGBD_CameraCompression3_parameters &_param);
	~EC_RGBD_CameraCompression3();
	bool Construct(EC_RGBD_CameraCompression3_parameters &_param);
	void release();	

	EC_RGBD_CameraCompression3_parameters param;
	
//	bool Record;
//	char Record_directory[512];
//	char Record_stem_depth[128];
//	char Record_stem_bgr[128];
//	int Record_number_digits;
	
	/// FILE *fSubDir_w; not used anymore, we prefer to launch ''
	///  ListEntriesInDir once and for all after recording is done
	///  and ReadInfoNbSubDir for every time we read the recorded data

	#ifdef USE_INFO_FILE
	FILE *fSubDir_r;
	#else
		int CURRENT_STAMP_INDEX, LAST_STAMP_INDEX;
	#endif
	bool REVERSE_NAME;
	
	bool USE_FRAME_DIFF;
	float pct_moving;
	depth_io_ClassBuffer DisplayMovingFrame;
	float threshold_motion_contrast, threshold_pct_motion;
	
	bool Record_period;
	int Record_period_gap;
	int delta_time_last_recorded;
	
	int last_time_recorded_year, last_time_recorded_month, last_time_recorded_day, last_time_recorded_hour, last_time_recorded_minute, last_time_recorded_second, last_time_recorded_millisecond;
	double last_time_recorded_unixtime;
	
	bool RECORDED, INITIALISED, REACHED_WANTED_START_TIME, REACHED_WANTED_STOP_TIME;
//	int Current_Frame_Index;
	JpegFile jpgfile; 
	//JpegFile linjpg;
	//depth_io_ClassBuffer tempF;
	//depth_io_ClassBufferUS tempUS;
	//int Debug, printout;
	int WW, HH;
	//depth_io_ClassBufferUC colour_image; //bool COLOUR_IMAGE_ON;
	//depth_io_ClassBuffer MapXd, MapYd, MapZd;
	depth_io_ClassBufferBOOL MapHasDepth;
	depth_io_ClassBufferBOOL prev_MapHasDepth;
	float a11, a22, cx, cy;
	struct_read_write_depth RW;
	depth_io_ClassBufferChar timestamp;//[27];
		
	float *DepthMap;
	unsigned char *ColourImage;


	//bool apply_with_index(bool RECORD_NOW, int current_frame, int debug);
	/// int current_frame IMPORTNAT for  hostoy index to save in buffer
	bool apply_with_timestamp(bool RECORD_NOW, int current_frame, int year, int month, int day, int hour, int minute, int second, int millisecond, int debug);
	
	bool _apply(bool RECORD_NOW, //float *DepthMap, unsigned char *ColourImage,
		//bool SAVE_WITH_TIMESTAMP, 
		int current_frame, 
		int year, int month, int day, int hour, int minute, int second, int millisecond, int debug);

//	bool recording_from_buffer(int start_frame_index, int stop_frame_index, 
//		int current_frame,
//		int print, int debug);

	bool recording_from_buffer(
		int start_year, int start_month, int start_day, int start_hour, int start_minute, int start_second, int start_millisecond,
		int stop_year, int stop_month, int stop_day, int stop_hour, int stop_minute, int stop_second, int stop_millisecond,
		int print, int debug);//int number_digits);

	bool _recording_from_buffer(
		//bool SAVE_WITH_TIMESTAMP,
		int start_year, int start_month, int start_day, int start_hour, int start_minute, int start_second, int start_millisecond,
		int stop_year, int stop_month, int stop_day, int stop_hour, int stop_minute, int stop_second, int stop_millisecond,
		int start_frame_index, int stop_frame_index, int current_frame,
	//	char *directory, // where the 4 files will be saved
	//	char *stem_depth,//_rle, char *stem_ref, char *stem_jpg, char *stem_err,
	//	bool COLOUR_IMAGE_ON, char *stem_bgr,
	//	int number_digits, 
		int print, int debug);

	
	bool LoadColourImage(char *FILENAME);//char *dir_in, char *stem_rgbimage, 
	//	int current_frame, 
	//	//int year, int month, int day, int hour, int minute, int second, int millisecond,
	//	char *_timestamp,
	//	bool SAVED_WITH_TIMESTAMP, int printout);
	
	bool READ(int current_frame, int debug);
		
	/*bool read(int current_frame, int debug);
	bool read(int year, int month, int day, int hour, int minute, int second, int millisecond, int debug);
	bool read(char *stem_stamp, int debug);

	bool _read(bool SAVED_WITH_TIMESTAMP, 
		int current_frame, int year, int month, int day, int hour, int minute, int second, int millisecond, 
		int debug);
	
	bool read_sub_dir(int current_frame, int debug);
	*/
	
	/// read or write
	char depth_string[512], bgr_string[512];
	
	int _CurrentFrame; bool _CurrentFrame_active;
	bool SetCurrentFrame(int val);
	//FirstIndexSavedInSubDirectory
	int _CurrentYear, _CurrentMonth, _CurrentDay, _CurrentHour, _CurrentMinute, _CurrentSecond, _CurrentMillisecond;
	bool _CurrentTimeStamp_active;
	bool SetCurrentTimeStamp(int year, int month, int day, int hour, int minute, int second, int millisecond);
	
	bool SetCurrentTimeStamp(char *src);
	char _CurrentStampString[100]; bool _CurrentStampString_active;
	
	bool Read_FindNextFolder_and_update_CurrentTime(int debug);
	bool Read(bool USE_COLOUR_IMAGE, int debug);
	

	bool read_for_calib_tool(char *depth_filename, char *bgr_filename);
	bool read_for_calib_tool(char *depth_filename);
	
	int VERIFICATION;

//	void output_to_cvMat_depth(float *depthMap);//unsigned short *depthMap);
//	void output_to_cvMat_bgrImage(unsigned char *bgrImage);
//	void input(float *depthMap);//unsigned short *depthMap);
//	void input(float *depthMap, //unsigned short *depthMap, 
//			   unsigned char *bgrImage);
	//#endif
//	float GetDepthAt(int pixel_index);
//	void SetDepthAt(int pixel_index, float val);
//	unsigned char GetBgrImageAt(int pixel_index);
//	void SetBgrImageAt(int pixel_index, unsigned char val);

	float GetIntrinsic_a11();
	float GetIntrinsic_a22();
	float GetIntrinsic_cx();
	float GetIntrinsic_cy();
	
///	int CurrentNbFramesSavedInSubDirectory;
///	int CurrentSubDirectoryIndex;
	
	char temp_string[512], temp_string2[512], temp_strdest[10], _temp_str[512];
	
	depth_io_ClassBufferChar1D TimeStamps;
	depth_io_ClassBufferChar1D SortedStamps;
	depth_io_ClassBufferDOUBLE UnixTimes;
	depth_io_ClassBufferINT SortedIndex;
	
	char CurrentFolderStringDay[512];
	char CurrentFolderStringHour[512];
	char CurrentFolderStringMinute[512];
	//int FirstIndexSavedInSubDirectory;
	//depth_io_ClassBufferChar FirstTimeStampSavedInSubDirectory;
	
	//int HistoryCounter;
	//int GetHistoryCorrespondingIndex(int frame_index);
	//int GetHistoryCorrespondingTimeStamp(char *timestamp, int frame_index);
	depth_io_ClassBuffer1D HistoryDepth; // [0:65,535] for unsigned short int
	depth_io_ClassBufferUC1D HistoryBGR;
	depth_io_ClassBufferChar1D HistoryTimeStamp;
	depth_io_ClassBufferINT HistoryYear, HistoryMonth, HistoryDay, HistoryHour, HistoryMinute, HistorySecond, HistoryMillisecond;
	depth_io_ClassBufferDOUBLE HistoryUnixTimes;
	
	int GetSizeHistory();
	int GetHistoryIndex();
	int GetHistoryOldest();

    std::string& getCurrentTimestamp();

	bool LOGOUT;
private:
	int SizeHistory;
	int HistoryModCounter, o_HistoryIndex; 
	/// o_HistoryIndex = HistoryModCounter, however, at the end of apply modcounter updated and for the main program we cannot use the correct one (non updated before the next framne)
	
	bool SubDirHandle(/*bool SAVE_WITH_TIMESTAMP, */int current_frame,
		int year, int month, int day, int hour, int minute, int second, int millisecond
	);
	bool SubDirHandle_for_buffer_recording(
		int year, int month, int day, int hour, int minute, int second, int millisecond);
	//void SubDirUpdate();


    std::string currentTimeStamp;


};

#endif


			
