/*
 * CSAllScenarios.h
 *
 *  Created on: 26 avr. 2010
 *      Author: bboulay
 */

#ifndef CSALLSCENARIOS_H_
#define CSALLSCENARIOS_H_

#include "CSScenario.h"
#include <iostream>
#include <fstream>
#include <vector>
#include <tr1/memory>
//#include <std::tr1/make_shared.hpp>

class CSScenario;

class CSAllScenarios {
public:
	CSAllScenarios();
	virtual ~CSAllScenarios();

	void read(std::string i_file, std::map<std::string, double> i_thresholdByEventType, std::map<std::string, int> i_levelAlarm);
	void readConstants(std::string i_block);

	void fillConstraintsConstants();
	void classifyConstraints();

	void createModelTree();

	void rewriteAgentOperator();

	void print();

public:
	std::string m_name;
	
	//type / scenarios
	std::map<std::string, std::vector<std::tr1::shared_ptr<CSScenario> > > m_allScenarios;

	std::map<std::string, double> m_allConstants;

	std::map<std::string, std::vector<std::tr1::shared_ptr<CSScenario> > > m_modelsTree;

};

#endif /* CSALLSCENARIOS_H_ */
