/*
 * CSScenarioInstance.h
 *
 *  Created on: 7 mai 2010
 *      Author: bboulay
 */

#ifndef CSSCENARIOINSTANCE_H_
#define CSSCENARIOINSTANCE_H_

#include <list>
#include <tr1/memory>
#include "CSScenario.h"
#include "CSAgent.h"
#include "CSComponent.h"
//#include "CSAccessor.h"
//#include "CSModelInstance.h"

class CSScenarioInstance {
public:
	CSScenarioInstance();
	CSScenarioInstance(const CSScenarioInstance &i_instance);
	virtual ~CSScenarioInstance();

	bool recognisePrimitiveState();

public:

	std::tr1::shared_ptr<CSScenario> m_model;
	//name in the model - and agent// it will also contains the components
	std::map<std::string,std::tr1::shared_ptr<CSAgent> > m_agent;
	//std::map<std::string,CSModelInstance> m_agent;
	//std::map<std::string, int> ID;
	std::tr1::shared_ptr<CSTimeStamp> m_beginTime;
	std::tr1::shared_ptr<CSTimeStamp> m_endTime;

	std::string			m_sensorSource;
	int m_id;
	double m_confidence;

	static double m_const_TimeSearch;



};

#endif /* CSSCENARIOINSTANCE_H_ */
