#ifndef SUPCOMPOSERNODEDATASTREAM_H
#define SUPCOMPOSERNODEDATASTREAM_H

#include "supComposerExport.h"

#include <dtkComposer/dtkComposerNodeLeafData.h>

#include <QtCore>

class supComposerNodeDataStreamPrivate;

class SUPCOMPOSER_EXPORT supComposerNodeDataStream : public QObject, public dtkComposerNodeLeafData
{
    Q_OBJECT

public:
     supComposerNodeDataStream(void);
    ~supComposerNodeDataStream(void);

public:
    void run(void);

public:
    inline QString type(void) {
        return "supDataStream";
    }

    inline QString titleHint(void) {
        return "Stream";
    }

    inline QString inputLabelHint(int port) {
        switch(port) {
        case 0:
            return "url";
        case 1:
            return "device";
        case 2:
            return "fps";
        case 3:
            return "resolution";
        default:
            return dtkComposerNodeLeafData::inputLabelHint(port);
        };
    }

    inline QString outputLabelHint(int port) {
        switch(port) {
        case 0:
            return "stream";
        default:
            return dtkComposerNodeLeafData::outputLabelHint(port);
        };
    }
    inline bool isAbstractData(void) const {
        return true;
    }

    inline QString abstractDataType(void) const {
        return "supAbstractDataStream";
    }

private:
    supComposerNodeDataStreamPrivate *d;
};

#endif
