#ifndef INFORMATION3D_H
#define INFORMATION3D_H

#include <opencv2/core/core.hpp>
#include "supCoreExport.h"

class SUPCORE_EXPORT Information3D
{
public:
    Information3D();
    Information3D(const Information3D &other):  m_height(   other.getHeight()),
                                                m_width(    other.getWidth()),
                                                m_depth(    other.getDepth()),
                                                m_position( other.getPosition()),
                                                m_highestPosition(  other.getHighestPosition()),
                                                m_lowestPosition(   other.getLowestPosition()),
                                                m_centroidPosition( other.getCentroidPosition())
                                                {}

public:
    void setHeight(float height);
    void setWidth(float width);
    void setDepth(float depth);
    void setPosition(cv::Point3f position);
    void setHighestPosition(cv::Point3f position);
    void setLowestPosition(cv::Point3f position);
    void setCentroidPosition( cv::Point3f position);

    float getHeight() const;
    float getWidth() const;
    float getDepth() const;
    cv::Point3f getPosition() const;
    cv::Point3f getHighestPosition() const;
    cv::Point3f getLowestPosition() const;
    cv::Point3f getCentroidPosition() const;

private:
    float m_height;
    float m_width;
    float m_depth;
    cv::Point3f m_position, m_highestPosition, m_lowestPosition, m_centroidPosition;

};

#endif // INFORMATION3D_H
