#ifndef SUPABSTRACTDATASTREAM_H
#define SUPABSTRACTDATASTREAM_H

#include "supCoreExport.h"

#include <dtkCore/dtkAbstractData.h>
#include <supCore/supAbstractDataCalibration.h>


class supAbstractDataStreamPrivate;

class SUPCORE_EXPORT supAbstractDataStream : public dtkAbstractData
{
    Q_OBJECT

public:
             supAbstractDataStream(void);
             supAbstractDataStream(const supAbstractDataStream& other);
    virtual ~supAbstractDataStream(void);

    supAbstractDataStream* clone(void);
    supAbstractDataStream& operator = (const supAbstractDataStream& other);

protected:
    virtual void copy(const dtkAbstractData& other);


public:
    virtual const QUrl& url(void) const;
    virtual void url(const QUrl& url);

    virtual QString device(void) const;
    virtual void device(QString);

    virtual QString streamName(void) const;
    virtual void streamName(QString);

    virtual supAbstractDataCalibration getCameraCalibration() const;
    virtual void setCameraCalibration(supAbstractDataCalibration& i_camera);

    virtual int fps(void) const;
    virtual void fps(int);

    virtual QString resolution(void) const;
    virtual void resolution(QString);


private:
    DTK_DECLARE_PRIVATE(supAbstractDataStream)
};

Q_DECLARE_METATYPE(QSharedPointer< supAbstractDataStream >)
Q_DECLARE_METATYPE(QSharedPointer< supAbstractDataStream >*)

#endif
