#ifndef SUPABSTRACTPROCESSCLASSIFIER_P_H
#define SUPABSTRACTPROCESSCLASSIFIER_P_H

#include "supAbstractProcess_p.h"

#include "supAbstractDataCalibration.h"
#include "supDataBlob.h"

#include "supDataPhysicalObject.h"

class supAbstractProcessClassifier;

////////////////////////////////////////////////////
// supAbstractProcessClassifierPrivate interface
////////////////////////////////////////////////////

class DTKCORE_EXPORT supAbstractProcessClassifierPrivate : public supAbstractProcessPrivate
{
    public:
        supAbstractProcessClassifierPrivate(supAbstractProcessClassifier *q = 0) : supAbstractProcessPrivate(q) {}
        supAbstractProcessClassifierPrivate(const supAbstractProcessClassifierPrivate& other) : supAbstractProcessPrivate(other), calibration(other.calibration), blobs(other.blobs) {}

    public:
        virtual ~supAbstractProcessClassifierPrivate(void) {}

    public: // Input
        QSharedPointer< supAbstractDataCalibration > calibration;
        QList< QSharedPointer< supDataBlob > > blobs;

    public: // Output
        QList< QSharedPointer< supDataPhysicalObject > > physicals;
};

////////////////////////////////////////////////////
// supAbstractProcessClassifier protected constructors
////////////////////////////////////////////////////

DTK_IMPLEMENT_PRIVATE(supAbstractProcessClassifier, supAbstractProcess)

#endif

