/* supAbstractProcessFrameToFrameTracker.h ---
 *
 * Author: %Author%
 */

/* Commentary:
 *
 */

/* Change log:
 *
 */

#ifndef SUPABSTRACTPROCESSFRAMETOFRAMETRACKER_H
#define SUPABSTRACTPROCESSFRAMETOFRAMETRACKER_H

#include <supCore/supAbstractProcess.h>

#include "supCoreExport.h"

#include "supDataImage.h"
#include "supDataPhysicalObject.h"
#include "supDataLinkedPhysicalObject.h"
#include "supDataActor.h"

#include "synchronizer.h"
#include <QSharedPointer>






class supAbstractProcessFrameToFrameTrackerPrivate;

// /////////////////////////////////////////////////////////////////
// supAbstractProcessFrameToFrameTracker interface
// /////////////////////////////////////////////////////////////////

class SUPCORE_EXPORT supAbstractProcessFrameToFrameTracker : public supAbstractProcess
{
    Q_OBJECT

public:
             supAbstractProcessFrameToFrameTracker(void);
             supAbstractProcessFrameToFrameTracker(const supAbstractProcessFrameToFrameTracker& other);
    virtual ~supAbstractProcessFrameToFrameTracker(void);

    virtual void setParameterFile( const std::string &fileName, const std::string commonPath="") = 0;
    virtual void apply(const supDataImage&, const PhysicalObjs&, SpLinkedPhysicalObjectList&) = 0;
    virtual void applyLTT(const sup::SpLinkedPhysicalObjectInterfaceList& i_linkedPOList_t,
    							std::list <QSharedPointer < supDataActor > > &o_actors_t) = 0;

//    virtual void applyLTT(const sup::SpLinkedPhysicalObjectInterfaceList& i_linkedPOList_t,
//        							std::list <QSharedPointer < supDataTrackedPhysicalObject > > &) = 0;


private:
    DTK_DECLARE_PRIVATE(supAbstractProcessFrameToFrameTracker);

};

#endif

