/* supAbstractProcessGroupTracker.h ---
 *
 * Author: %Author%
 */

/* Commentary:
 *
 */

/* Change log:
 *
 */

#ifndef SUPABSTRACTPROCESSGROUPTRACKER_H
#define SUPABSTRACTPROCESSGROUPTRACKER_H

#include "supAbstractProcess.h"
#include "supAbstractDataCalibration.h"
#include "supDataContext.h"

#include "supCoreExport.h"
#include <supCore/supDataImage.h>
#include "supDataActor.h"

class supAbstractProcessGroupTrackerPrivate;

// /////////////////////////////////////////////////////////////////
// supAbstractProcessGroupTracker interface
// /////////////////////////////////////////////////////////////////

class SUPCORE_EXPORT supAbstractProcessGroupTracker : public supAbstractProcess
{
    Q_OBJECT

public:
    supAbstractProcessGroupTracker(void);
    supAbstractProcessGroupTracker(const supAbstractProcessGroupTracker& other);
    virtual ~supAbstractProcessGroupTracker(void);

    void setCalibration( QSharedPointer< supAbstractDataCalibration >& calibration );
    void setContext( QSharedPointer< supDataContext >& context );
    virtual void setParameterFile( const std::string & parameterFilePath);
    virtual void setFrame(QSharedPointer<supDataImage> frame);
    virtual void setActors(QList <QSharedPointer < supDataActor > > & actors);
    virtual bool init() = 0;
    virtual void process() = 0;
    virtual QList <QSharedPointer < supDataActor > > & getActors();

private:
    DTK_DECLARE_PRIVATE(supAbstractProcessGroupTracker);
};

#endif

