#ifndef SUPABSTRACTPROCESSREACQUISITION_H
#define SUPABSTRACTPROCESSREACQUISITION_H

#include "supAbstractProcess.h"

#include "supDataActor.h"
#include "supDataImage.h"

#include "supCoreExport.h"

class supAbstractProcessReAcquisitionPrivate;

// /////////////////////////////////////////////////////////////////
// supAbstractProcessReAcquisition interface
// /////////////////////////////////////////////////////////////////

class SUPCORE_EXPORT supAbstractProcessReAcquisition : public supAbstractProcess
{
    Q_OBJECT

public:
             supAbstractProcessReAcquisition(void);
             supAbstractProcessReAcquisition(const supAbstractProcessReAcquisition& other);
    virtual ~supAbstractProcessReAcquisition(void);

public: //Input
    void setImage(QSharedPointer< supDataImage > i_image);
    void setActors(QList< QSharedPointer< supDataActor > > i_actors);
    void setMTSPath(std::string i_path);

public: //Process
    //virtual bool applyInterpolation() = 0;
    //virtual bool applyErrorDetection() = 0;
    virtual bool applyReAcquisition() = 0;

public: //Process
    QList< QSharedPointer< supDataActor > > getActors(void);

private:
    DTK_DECLARE_PRIVATE(supAbstractProcessReAcquisition);
};

#endif

