#ifndef SUPABSTRACTPROCESSSEGMENTATION_H
#define SUPABSTRACTPROCESSSEGMENTATION_H

#include "supAbstractProcess.h"
#include "supCoreExport.h"

class supAbstractProcessSegmentationPrivate;

class supDataImage;


// /////////////////////////////////////////////////////////////////
// supAbstractProcessSegmentation interface
// /////////////////////////////////////////////////////////////////

class SUPCORE_EXPORT supAbstractProcessSegmentation : public supAbstractProcess
{
    Q_OBJECT

public:
             supAbstractProcessSegmentation(void);
             supAbstractProcessSegmentation(const supAbstractProcessSegmentation& other);
    virtual ~supAbstractProcessSegmentation(void);

public: // Input
    void setAcquisitionImage( QSharedPointer< supDataImage >& i_acquisiton_image );

public: // Process
    virtual bool segment(void) = 0;

public: // Output
    QSharedPointer< supDataImage >& getSegmentationImage(void);

private:
    DTK_DECLARE_PRIVATE(supAbstractProcessSegmentation)
};

#endif
