#ifndef SUPABSTRACTPROCESSSEGMENTATION_P_H
#define SUPABSTRACTPROCESSSEGMENTATION_P_H

#include "supAbstractProcess_p.h"

#include "supDataImage.h"

class supAbstractProcessSegmentation;

////////////////////////////////////////////////////
// supAbstractProcessSegmentationPrivate interface
////////////////////////////////////////////////////

class DTKCORE_EXPORT supAbstractProcessSegmentationPrivate : public supAbstractProcessPrivate
{
    public:
        supAbstractProcessSegmentationPrivate(supAbstractProcessSegmentation *q = 0) : supAbstractProcessPrivate(q) {}
        supAbstractProcessSegmentationPrivate(const supAbstractProcessSegmentationPrivate& other) : supAbstractProcessPrivate(other), acquisition_image(other.acquisition_image), segmentation_image(other.segmentation_image) {}

    public:
        virtual ~supAbstractProcessSegmentationPrivate(void) {}

    public: // Input
        QSharedPointer< supDataImage > acquisition_image;

    public: // Output
        QSharedPointer< supDataImage > segmentation_image;
};

////////////////////////////////////////////////////
// supAbstractProcessSegmentation protected constructors
////////////////////////////////////////////////////

DTK_IMPLEMENT_PRIVATE(supAbstractProcessSegmentation, supAbstractProcess)

#endif
