#ifndef SUPDATABLOB_H
#define SUPDATABLOB_H

#include "supAbstractData.h"

#include "supCoreExport.h"

#include <opencv2/core/core.hpp>

class supDataBlobPrivate;

// /////////////////////////////////////////////////////////////////
// supDataBlob interface
// /////////////////////////////////////////////////////////////////

class SUPCORE_EXPORT supDataBlob : public supAbstractData
{
    Q_OBJECT

public:
             supDataBlob(void);
             supDataBlob(const supDataBlob& other);
    virtual ~supDataBlob(void);

public:
    virtual supDataBlob *clone(void);
public:
    supDataBlob& operator = (const supDataBlob& other);
protected:
    virtual void copy(const dtkAbstractObject& other);

public:
    QString identifier(void) const;

public:
    void setBoundingBox2D(const cv::Rect& rect);
    const cv::Rect& getBoundingBox2D() const;

    //QtBoundingBox
    void setBoundingBox2D_qt(const QRect & rect);
    const QRect & getBoundingBox2D_qt()const;

private:
    DTK_DECLARE_PRIVATE(supDataBlob)
};

Q_DECLARE_METATYPE(QSharedPointer< supDataBlob >)
Q_DECLARE_METATYPE(QSharedPointer< supDataBlob >*)
Q_DECLARE_METATYPE(QList< QSharedPointer< supDataBlob > >)
Q_DECLARE_METATYPE(QList< QSharedPointer< supDataBlob > >*)

#endif

