#ifndef SUPABSTRACTDATAIMAGE_H
#define SUPABSTRACTDATAIMAGE_H

#include "supAbstractData.h"

#include "supCoreExport.h"

#include <opencv2/core/core.hpp>

class supDataImagePrivate;

// /////////////////////////////////////////////////////////////////
// supDataImage interface
// /////////////////////////////////////////////////////////////////

class SUPCORE_EXPORT supDataImage : public supAbstractData
{
    Q_OBJECT

public:
             supDataImage(void);
             supDataImage(const supDataImage& other);
    virtual ~supDataImage(void);

// /////////////////////////////////////////////////////////////////
// Composition functionnality
// /////////////////////////////////////////////////////////////////

public:
    supDataImage *clone(void);
    supDataImage& operator = (const supDataImage& other);
    QString identifier(void) const;

protected:
    virtual void copy(const dtkAbstractObject& other);

// /////////////////////////////////////////////////////////////////
// Read and Write functionnality
// /////////////////////////////////////////////////////////////////
public:
    bool read(const QString& file);
    bool write(const QString& file);

// /////////////////////////////////////////////////////////////////
// Application 
// /////////////////////////////////////////////////////////////////
public:
    void setImage(const cv::Mat& i_image);
    const cv::Mat& getImage() const;

private:
    DTK_DECLARE_PRIVATE(supDataImage)
};

Q_DECLARE_METATYPE(QSharedPointer< supDataImage >)
Q_DECLARE_METATYPE(QSharedPointer< supDataImage >*)

#endif

