#ifndef SUPVIEWEVENTTIMELINE_H
#define SUPVIEWEVENTTIMELINE_H

#include "supCoreExport.h"

#include <dtkCore/dtkAbstractView.h>

#include <supCore/supDataImage.h>
#include <supCore/supDataBlob.h>
#include <supCore/supDataEvent.h>

class supViewEventTimelinePrivate;

struct Interval {
    CSynchronizer begin;
    CSynchronizer end;
};

struct DataEvent {
    QString eventName;
    int actorId;
    std::list <Interval> listOfInterval;
    QString alarmLevel;
};

class SUPCORE_EXPORT supViewEventTimeline : public dtkAbstractView
{
    Q_OBJECT

public:
             supViewEventTimeline(void);
             supViewEventTimeline(const supViewEventTimeline& other);
    virtual ~supViewEventTimeline(void);

public:
    void init();
    void setEvents(std::list< QSharedPointer<supDataEvent> > list, CSynchronizer actualTS);
    void updateDisplay ();
    void removeOldEvents();


public:
    QWidget* widget(void);

private:
    DTK_DECLARE_PRIVATE(supViewEventTimeline)

    std::list< DataEvent > listOfEvents;
    CSynchronizer actualTS;
};

// /////////////////////////////////////////////////////////////////
// 
// /////////////////////////////////////////////////////////////////

SUPCORE_EXPORT dtkAbstractView *createsupViewEventTimeline(void);

#endif
